<?php
if ( ! function_exists( 'solar_system_company_setup' ) ) :
function solar_system_company_setup() {

// Root path/URI.
define( 'SOLAR_SYSTEM_COMPANY_PARENT_DIR', get_template_directory() );
define( 'SOLAR_SYSTEM_COMPANY_PARENT_URI', get_template_directory_uri() );

// Root path/URI.
define( 'SOLAR_SYSTEM_COMPANY_PARENT_INC_DIR', SOLAR_SYSTEM_COMPANY_PARENT_DIR . '/inc');
define( 'SOLAR_SYSTEM_COMPANY_PARENT_INC_URI', SOLAR_SYSTEM_COMPANY_PARENT_URI . '/inc');

	// Add default posts and comments RSS feed links to head.
	add_theme_support( 'automatic-feed-links' );
	add_theme_support( 'wc-product-gallery-zoom' );
	add_theme_support( 'wc-product-gallery-slider' );

	/*
	 * Let WordPress manage the document title.
	 */
	add_theme_support( 'title-tag' );

	add_theme_support( 'responsive-embeds' );
	
	/*
	 * Enable support for Post Thumbnails on posts and pages.
	 */
	add_theme_support( 'post-thumbnails' );
	
	//Add selective refresh for sidebar widget
	add_theme_support( 'customize-selective-refresh-widgets' );
	
	/*
	 * Make theme available for translation.
	 */
	load_theme_textdomain( 'solar-system-company', get_stylesheet_directory() . '/languages' );
		
	// This theme uses wp_nav_menu() in one location.
	register_nav_menus( array(
		'primary'  => esc_html__( 'Primary Menu', 'solar-system-company' ),
	) );

	/*
	 * Switch default core markup for search form, comment form, and comments
	 * to output valid HTML5.
	 */
	add_theme_support( 'html5', array(
		'search-form',
		'comment-form',
		'comment-list',
		'gallery',
		'caption',
	) );
		
	add_theme_support('custom-logo');

	/*
	 * WooCommerce Plugin Support
	 */
	add_theme_support( 'woocommerce' );
	
	// Gutenberg wide images.
	add_theme_support( 'align-wide' );
	
	
	//Set up the WordPress core custom background feature.
	add_theme_support( 'custom-background', apply_filters( 'solar_system_company_custom_background_args', array(
		'default-color' => 'ffffff',
		'default-image' => '',
	) ) );
	
	/*
	 * This theme styles the visual editor to resemble the theme style,
	 * specifically font, colors, icons, and column width.
	 */
	add_editor_style( array( 'assets/css/editor-style.css', solar_system_company_google_font_url() ) );

    add_theme_support( 'custom-header', apply_filters( 'solar_system_company_custom_header_args', array(
		'default-image'          => get_template_directory_uri() . '/assets/images/custom-header.png',
		'default-text-color'     => 'ffffff',
		'width'                  => 2000, 
		'height'                 => 200,
		'flex-width'    		 => true,
		'flex-height'    		 => true,
        'uploads'            => true,
	)));


    /*
    * Enable support for Post Formats.
    *
    * See: https://codex.wordpress.org/Post_Formats
    */
    add_theme_support( 'post-formats', array('image','video','gallery','audio',) );


    //  --------------------------------------------- ENQUEUE ----------------------------------------------------- //

    /**
     * Implement the Custom Header feature.
     */
    require_once get_template_directory() . '/inc/custom-header.php';

    /**
     * Demo Import
     */
    require get_parent_theme_file_path( '/demo-import/demo-import-settings.php' );

    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_FREE_THEME_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_FREE_THEME_URL', 'https://www.seothemesexpert.com/products/free-solar-wordpress-theme' );
    }
    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_PRO_THEME_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_PRO_THEME_URL', 'https://www.seothemesexpert.com/products/solar-website-template' );
    }
    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_FREE_DOCS_THEME_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_FREE_DOCS_THEME_URL', 'https://demo.seothemesexpert.com/documentation/solar-system-company/' );
    }
    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_DEMO_THEME_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_DEMO_THEME_URL', 'https://demo.seothemesexpert.com/solar-system-company/' );
    }
    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_RATE_THEME_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_RATE_THEME_URL', 'https://wordpress.org/support/theme/solar-system-company/reviews/#new-post' );
    }
    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_SUPPORT_THEME_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_SUPPORT_THEME_URL', 'https://wordpress.org/support/theme/solar-system-company/' );
    }
    if ( ! defined( 'SOLAR_SYSTEM_COMPANY_THEME_BUNDLE_URL' ) ) {
        define( 'SOLAR_SYSTEM_COMPANY_THEME_BUNDLE_URL', 'https://www.seothemesexpert.com/products/wordpress-theme-bundle' );
    }

}
endif;
add_action( 'after_setup_theme', 'solar_system_company_setup' );

/**
 * Set the content width in pixels, based on the theme's design and stylesheet.
 *
 * Priority 0 to make it available to lower priority callbacks.
 *
 * @global int $content_width
 */
function solar_system_company_content_width() {
	$GLOBALS['content_width'] = apply_filters( 'solar_system_company_content_width', 1170 );
}
add_action( 'after_setup_theme', 'solar_system_company_content_width', 0 );

/**
 * Register widget area.
 *
 * @link https://developer.wordpress.org/themes/functionality/sidebars/#registering-a-sidebar
 */

function solar_system_company_widgets_init() {
	
	register_sidebar( array(
		'name' => __( 'Sidebar Widget Area', 'solar-system-company' ),
		'id' => 'solar-system-company-sidebar-primary',
		'description' => __( 'The Primary Widget Area', 'solar-system-company' ),
		'before_widget' => '<aside id="%1$s" class="widget %2$s wow fadeInUp">',
		'after_widget' => '</aside>',
		'before_title' => '<h4 class="widget-title">',
		'after_title' => '</h4><div class="title"><span class="shap"></span></div>',
	) );
	
	register_sidebar( array(
		'name' => __( 'Footer Widget Area', 'solar-system-company' ),
		'id' => 'solar-system-company-footer-widget-area',
		'description' => __( 'The Footer Widget Area', 'solar-system-company' ),
		'before_widget' => '<div class="footer-widget col-lg-3 col-sm-6 wow fadeIn" data-wow-delay="0.5s"><aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside></div>',
		'before_title' => '<h5 class="widget-title w-title">',
		'after_title' => '</h5><span class="shap"></span>',
	) );
}
add_action( 'widgets_init', 'solar_system_company_widgets_init' );

/**
 * All Styles & Scripts.
 */

require_once get_template_directory() . '/inc/enqueue.php';

/**
 * Nav Walker fo Bootstrap Dropdown Menu.
 */

require_once get_template_directory() . '/inc/class-wp-bootstrap-navwalker.php';

/**
 * Custom template tags for this theme.
 */
require_once get_template_directory() . '/inc/template-tags.php';

/**
 * Custom functions that act independently of the theme templates.
 */
require_once get_template_directory() . '/inc/extras.php';

/**
 * Customizer additions.
 */
require_once get_template_directory() . '/inc/customizer.php';

require_once get_template_directory() . '/inc/fonts.php';

require_once get_template_directory() . '/wptt-webfont-loader.php';


function solar_system_company_custom_controls() {
	load_template( trailingslashit( get_template_directory() ) . '/inc/customizer/customizer-custom-controls.php' );
}
add_action( 'customize_register', 'solar_system_company_custom_controls' );

// Sanitize the input
function solar_system_company_sanitize_sidebar_position( $solar_system_company_input ) {
    $solar_system_company_valid = array( 'right', 'left' );

    if ( in_array( $solar_system_company_input, $solar_system_company_valid ) ) {
        return $solar_system_company_input;
    } else {
        return 'right';
    }
}


add_filter( 'nav_menu_link_attributes', 'solar_system_company_dropdown_data_attribute', 20, 3 );
/**
 * Use namespaced data attribute for Bootstrap's dropdown toggles.
 *
 * @param array    $atts HTML attributes applied to the item's `<a>` element.
 * @param WP_Post  $item The current menu item.
 * @param stdClass $args An object of wp_nav_menu() arguments.
 * @return array
 */
function solar_system_company_dropdown_data_attribute( $atts, $item, $args ) {
    if ( is_a( $args->walker, 'WP_Bootstrap_Navwalker' ) ) {
        if ( array_key_exists( 'data-toggle', $atts ) ) {
            unset( $atts['data-toggle'] );
            $atts['data-bs-toggle'] = 'dropdown';
        }
    }
    return $atts;
}

function solar_system_company_remove_theme_customizer_setting($wp_customize) {
    // Remove the setting
    $wp_customize->remove_setting('display_header_text');
    // Remove the control
    $wp_customize->remove_control('display_header_text');
}
add_action('customize_register', 'solar_system_company_remove_theme_customizer_setting', 20); 
// Use a priority greater than the one used for adding the setting


// Set the number of products per row to 3 on the shop page
add_filter('loop_shop_columns', 'solar_system_company_custom_shop_loop_columns');

if (!function_exists('solar_system_company_custom_shop_loop_columns')) {
    function solar_system_company_custom_shop_loop_columns() {
        // Retrieve the number of columns from theme customizer setting (default: 3)
        $solar_system_company_columns = get_theme_mod('solar_system_company_custom_shop_per_columns', 3);
        return $solar_system_company_columns;
    }
}

// Set the number of products per page on the shop page
add_filter('loop_shop_per_page', 'solar_system_company_custom_shop_per_page', 20);

if (!function_exists('solar_system_company_custom_shop_per_page')) {
    function solar_system_company_custom_shop_per_page($solar_system_company_products_per_page) {
        // Retrieve the number of products per page from theme customizer setting (default: 9)
        $solar_system_company_products_per_page = get_theme_mod('solar_system_company_custom_shop_product_per_page', 9);
        return $solar_system_company_products_per_page;
    }
}

/**
 * Generate Google fonts URL.
 */
function solar_system_company_google_font_url() {
    $solar_system_company_font_family = array(
        'Mali:ital,wght@0,200;0,300;0,400;0,500;0,600;0,700;1,200;1,300;1,400;1,500;1,600;1,700',
        'Roboto+Condensed:ital,wght@0,100;0,200;0,300;0,400;0,500;0,600;0,700;0,800;0,900;1,100;1,200;1,300;1,400;1,500;1,600;1,700;1,800;1,900'
    );

    $solar_system_company_query_args = array(
        'family' => rawurlencode(implode('|', $solar_system_company_font_family)),
    );

    return add_query_arg($solar_system_company_query_args, 'https://fonts.googleapis.com/css');
}

/**
 * Enqueue theme styles and scripts.
 */
function solar_system_company_scripts_styles() {
    // Enqueue Google Fonts
    wp_enqueue_style('solar-system-company-google-fonts', solar_system_company_google_font_url(), array(), null);
    
    // Enqueue other styles and scripts as needed
    wp_enqueue_style('solar-system-company-main-style', get_stylesheet_uri(), array(), '1.0.0');
    // Add more enqueuing here if needed
}
add_action('wp_enqueue_scripts', 'solar_system_company_scripts_styles');

function solar_system_company_fonts_scripts() {
	$solar_system_company_headings_font = esc_html(get_theme_mod('solar_system_company_headings_text'));
	$solar_system_company_body_font = esc_html(get_theme_mod('solar_system_company_body_text'));

	if( $solar_system_company_headings_font ) {
		wp_enqueue_style( 'solar-system-company-headings-fonts', '//fonts.googleapis.com/css?family='. $solar_system_company_headings_font );
	} else {
		wp_enqueue_style( 'solar-system-company-source-sans', '//fonts.googleapis.com/css?family=Lato:400,700,400italic,700italic');
	}
	if( $solar_system_company_body_font ) {
		wp_enqueue_style( 'solar-system-company-body-fonts', '//fonts.googleapis.com/css?family='. $solar_system_company_body_font );
	} else {
		wp_enqueue_style( 'solar-system-company-source-body', '//fonts.googleapis.com/css?family=Source+Sans+Pro:400,300,400italic,700,600');
	}
}
add_action( 'wp_enqueue_scripts', 'solar_system_company_fonts_scripts' );

function solar_system_company_customize_css() {
    $solar_system_company_dynamic_color = get_theme_mod( 'solar_system_company_dynamic_color_one', '#0cd4ff' );
    $solar_system_company_custom_css = ":root { --color-primary1: {$solar_system_company_dynamic_color}; }";
    wp_add_inline_style( 'solar-system-company-style', $solar_system_company_custom_css );
}
add_action( 'wp_enqueue_scripts', 'solar_system_company_customize_css' );

/**
 * Enqueue theme copyright alignment style.
 */
function solar_system_company_copyright_alignment_option() {
    // Get the alignment setting from the theme customizer.
    $solar_system_company_copyright_alignment = get_theme_mod('solar_system_company_copyright_alignment', 'center');

    // Start building the CSS string for the alignment.
    $solar_system_company_copyright_alignment_css = '
        .copyright-text, .footer-copyright, .footer-copyright a, p.copyright-text {
            text-align: ' . esc_attr($solar_system_company_copyright_alignment) . ';
        }
    ';

    // Add the inline style to the theme's main stylesheet.
    wp_add_inline_style('solar-system-company-style', $solar_system_company_copyright_alignment_css);
}

add_action('wp_enqueue_scripts', 'solar_system_company_copyright_alignment_option');

// Helper function to get page ID by slug
function get_page_id_by_slug($solar_system_company_slug) {
    $solar_system_company_page = get_page_by_path($solar_system_company_slug); // Get the page by slug
    return $solar_system_company_page ? $solar_system_company_page->ID : 0;   // Return the page ID or 0 if not found
}

// Show Admin Notice
function solar_system_company_promo_notice() {
    if (get_option('solar_system_company_notice_dismissed')) {
        return;
    }

    if (isset($_GET['page']) && $_GET['page'] === 'solarsystemcompany-wizard') {
        return;
    }

    $solar_system_company_theme = wp_get_theme();
    $solar_system_company_theme_title = $solar_system_company_theme->get( 'Name' );
    $solar_system_company_theme_version = $solar_system_company_theme->get( 'Version' );

    ?>
    <div class="notice solar-system-company-notice is-dismissible">
        <div>
            <h3>
                <span><?php echo esc_html( '(Version: ' . $solar_system_company_theme_version . ')' ); ?></span><br>
                <?php esc_html_e( 'Thank you for choosing,', 'solar-system-company'); ?>
                <?php echo esc_html( $solar_system_company_theme_title ); ?> <?php esc_html_e( '!!!', 'solar-system-company'); ?>
            </h3>
            <p><?php esc_html_e( 'Welcome! You can now easily start building your website using our beautiful and user-friendly themes. No need to worry about setup — with our one-click demo importer, your site can look just like the demo in minutes. All the tools and information you need to get started are right here!', 'solar-system-company'); ?></p>
            <a class="button button-primary solar-system-company-buy-now" href="<?php echo esc_url(admin_url('themes.php?page=solarsystemcompany-wizard')); ?>" target="_blank">
                <?php esc_html_e( 'One Click Demo Import', 'solar-system-company') ?>
            </a>
            <a class="button button-primary solar-system-company-bundle-button" target="_blank" href="<?php echo esc_url( SOLAR_SYSTEM_COMPANY_THEME_BUNDLE_URL ); ?>">
                <?php echo esc_html__( 'Get All 60+ Themes @ $79', 'solar-system-company' ); ?>
            </a>
        </div>
        <div class="solar-system-company-image-wrap">
            <img src="<?php echo esc_url(get_stylesheet_directory_uri() . '/screenshot.png'); ?>">
        </div>
        <canvas id="solar-system-company-notice-confetti"></canvas>
    </div>
    <?php
}
add_action('admin_notices', 'solar_system_company_promo_notice');

add_action('wp_ajax_solar_system_company_dismiss_notice', 'solar_system_company_dismiss_notice');
function solar_system_company_dismiss_notice() {
    update_option('solar_system_company_notice_dismissed', true);
    wp_send_json_success();
}

add_action('after_switch_theme', 'solar_system_company_reset_notice_on_activation');
function solar_system_company_reset_notice_on_activation() {
    delete_option('solar_system_company_notice_dismissed');
}

function solar_system_company_enqueue_admin_assets() {
    wp_enqueue_script(
        'solar-system-company-confetti',
        get_template_directory_uri() . '/demo-import/assets/js/confetti/confetti.min.js',
        ['jquery'],
        null,
        true
    );

    wp_enqueue_script(
        'solar-system-company-notice-confetti-js',
        get_template_directory_uri() . '/demo-import/assets/js/plugin-update-notice.js',
        ['solar-system-company-confetti'],
        null,
        true
    );

    wp_enqueue_script(
        'solar-system-company-notice-dismiss',
        get_template_directory_uri() . '/demo-import/assets/js/notice-dismiss.js',
        ['jquery'],
        null,
        true
    );
}
add_action('admin_enqueue_scripts', 'solar_system_company_enqueue_admin_assets');